# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define repodir %{_javadir}/repository.jboss.com/jboss/jaxr/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag %{nil}

Name:           jboss-jaxr
Version:        2.0.1
Release:        7.1%{?dist}
Epoch:          0
Summary:        JBoss JAXR
License:        LGPLv2+
Group:          Development/Java
URL:            http://wiki.jboss.org/wiki/en/Jbossesb/JAXR
# rm -fr jboss-jaxr
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jaxr/tags/2.0.1/ jboss-jaxr
# tar czvf jboss-jaxr-2.0.1-src.tar.gz jboss-jaxr
Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:	%{name}-component-info.xml
Source3:        sign-unsigned-jars
Patch0:         %{name}-pom-xml.patch
Patch1:         %{name}-juddi-service-pom-xml.patch
Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-surefire-report
BuildRequires:  maven2-common-poms >= 1.0
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-site
BuildRequires:  codehaus-stax-api
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-common-logging-log4j >= 0:1.1
BuildRequires:  jbossws >= 0:3.1.2
BuildRequires:  jbossws-common >= 0:1.1.0
BuildRequires:  jboss5-libs >= 0:5.1.0
BuildRequires:  jboss-bootstrap >= 0:1.0.0
BuildRequires:  jboss-deployers >= 0:2.0.7
BuildRequires:  jboss-test >= 0:1.1.4
BuildRequires:  jbossws-parent >= 0:1.0.2
BuildRequires:  jboss-parent >= 0:4.0-0.CR1
BuildRequires:  jboss-javaee >= 0:5.0.1
BuildRequires:  jboss-javaee-poms >= 0:5.0.1
BuildRequires:  ws-scout >= 0:1.1.1
BuildRequires:  juddi >= 0:2.0.1
BuildRequires:  jbossweb >= 0:2.1.3
BuildRequires:  zip
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The JBoss Xml Registries.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n jboss-jaxr
%patch0 -b .sav
%patch1 -b .sav
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

mkdir external_repo
ln -s %{_javadir} external_repo/JPP 

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
%{_bindir}/mvn-jpp \
        -e \
        -Djboss.repository=file://%{_javadir}/repository.jboss.com \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.compiler.target=1.5 \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}/%{name}
cp -p modules/juddi-jaxr/target/juddi-jaxr-%{version}.jar %{buildroot}%{_javadir}/%{name}/juddi-jaxr-%{version}.jar
cp -p modules/juddi-jaxr/target/juddi-jaxr-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/juddi-jaxr-sources-%{version}.jar
cp -p modules/juddi-saaj/target/juddi-saaj-%{version}.jar %{buildroot}%{_javadir}/%{name}/juddi-saaj-%{version}.jar
cp -p modules/juddi-saaj/target/juddi-saaj-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}/juddi-saaj-sources-%{version}.jar

# Make sure juddi-saaj.jar inside the juddi-service.sar is the same as
# the standalone juddi-saaj.jar
rm -rf tmp
mkdir tmp
pushd tmp
unzip -qq ../modules/juddi-service/target/juddi-service.sar
rm ../modules/juddi-service/target/juddi-service.sar
rm juddi-saaj.jar
cp -p %{buildroot}%{_javadir}/%{name}/juddi-saaj-%{version}.jar juddi-saaj.jar
/bin/sh %{SOURCE3} jbosscodesign2009 .
zip -qr ../modules/juddi-service/target/juddi-service.sar .
popd
rm -r tmp

cp -p modules/juddi-service/target/juddi-service.sar %{buildroot}%{_javadir}/%{name}/juddi-service-%{version}.sar
cp -p modules/juddi-service/target/juddi-service-sources.jar %{buildroot}%{_javadir}/%{name}/juddi-service-sources-%{version}.jar

(cd %{buildroot}%{_javadir}/%{name} && ln -s juddi-jaxr-%{version}.jar juddi-jaxr.jar)
(cd %{buildroot}%{_javadir}/%{name} && ln -s juddi-jaxr-sources-%{version}.jar juddi-jaxr-sources.jar)
(cd %{buildroot}%{_javadir}/%{name} && ln -s juddi-saaj-%{version}.jar juddi-saaj.jar)
(cd %{buildroot}%{_javadir}/%{name} && ln -s juddi-saaj-sources-%{version}.jar juddi-saaj-sources.jar)
(cd %{buildroot}%{_javadir}/%{name} && ln -s juddi-service-%{version}.sar juddi-service.sar)
(cd %{buildroot}%{_javadir}/%{name} && ln -s juddi-service-sources-%{version}.jar juddi-service-sources.jar)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-parent.pom
%add_to_maven_depmap org.jboss.jaxr juddi-parent %{version} JPP/jboss-jaxr juddi-parent
cp -p modules/juddi-jaxr/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-jaxr.pom
%add_to_maven_depmap org.jboss.jaxr juddi-saaj %{version} JPP/jboss-jaxr juddi-saaj
cp -p modules/juddi-saaj/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-saaj.pom
%add_to_maven_depmap org.jboss.jaxr juddi-jaxr %{version} JPP/jboss-jaxr juddi-jaxr
cp -p modules/juddi-service/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-service.pom
%add_to_maven_depmap org.jboss.jaxr juddi-service %{version} JPP/jboss-jaxr juddi-service

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
# FIXME juddi-service is being uploaded as jar and component-matrix is looking for sar so changing pom
sed -i 's/packaging>jar/packaging>sar/g' modules/juddi-service/pom.xml
mvn-jpp -e deploy:deploy-file -DpomFile=modules/juddi-service/pom.xml -Dfile=modules/juddi-service/target/juddi-service.sar -DrepositoryId=maven2-brew -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew -DgroupId=org.jboss.jaxr -Dversion=%{version}

mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
cp -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{PATCH1} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-saaj.jar %{buildroot}%{repodirlib}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-jaxr.jar %{buildroot}%{repodirlib}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-service.sar %{buildroot}%{repodirlib}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-jaxr-sources.jar %{buildroot}%{repodirlib}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-saaj-sources.jar %{buildroot}%{repodirlib}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-service-sources.jar %{buildroot}%{repodirlib}
# replace @VERSION@ @TAG@ in component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
cp -p pom.xml %{buildroot}%{repodirlib}/juddi-parent.pom
cp -p modules/juddi-jaxr/pom.xml %{buildroot}%{repodirlib}/juddi-jaxr.pom
cp -p modules/juddi-saaj/pom.xml %{buildroot}%{repodirlib}/juddi-saaj.pom
cp -p modules/juddi-service/pom.xml %{buildroot}%{repodirlib}/juddi-service.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/juddi-jaxr-%{version}.jar
%{_javadir}/%{name}/juddi-jaxr.jar
%{_javadir}/%{name}/juddi-jaxr-sources-%{version}.jar
%{_javadir}/%{name}/juddi-jaxr-sources.jar
%{_javadir}/%{name}/juddi-saaj-%{version}.jar
%{_javadir}/%{name}/juddi-saaj.jar
%{_javadir}/%{name}/juddi-saaj-sources-%{version}.jar
%{_javadir}/%{name}/juddi-saaj-sources.jar
%{_javadir}/%{name}/juddi-service-%{version}.sar
%{_javadir}/%{name}/juddi-service.sar
%{_javadir}/%{name}/juddi-service-sources-%{version}.jar
%{_javadir}/%{name}/juddi-service-sources.jar
%{_datadir}/maven2/poms/JPP.%{name}-juddi-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-jaxr.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-saaj.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-service.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif


%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Mar 10 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-7.1
- Changing juddi-service.jar to juddi-service.sar in repolib maven2-brew

* Mon Nov 29 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-7
- Build with maven 2.2.1
- Add BR codehaus-stax-api, maven-deploy-plugin, maven-site-plugin

* Mon Jun 28 2010 David Walluck <dwalluck@redhat.com> 0:2.0.1-6
- sign jars inside of juddi-service sar

* Fri Jun 25 2010 David Walluck <dwalluck@redhat.com> 0:2.0.1-5
- rebuild to fix juddi-saaj.jar
- fix jar location
- fix file ownership
- fix repolib permissions
- fix GCJ support on RHEL-5
- clean up jpp-depmap

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-4.1.1
- rebuilt

* Thu Feb 18 2010 Fernando Nasser <fnasser@redhat.com> 2.0.1-4
- Use ws-scout and juddi packages
- Make sure juddi-saaj.jar inside the juddi-service.sar is the same as
  the standalone juddi-saaj.jar

* Thu Aug 13 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-3
- Fix component-info.xml

* Thu Aug 13 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-2
- Update component-info.xml

* Wed Aug 12 2009 Permaine Cheung <pcheung@redhat.com> 2.0.1-1
- Upgrade to 2.0.1
- Update tar ball for juddi 2.0.1 and scout 1.1.1
- Add poms to repolib

* Fri Aug 07 2009 Permaine Cheung <pcheung@redhat.com> 2.0.0-0.GA.2
- Fix version in maven fragment

* Wed Jul 29 2009 Permaine Cheung <pcheung@redhat.com> 2.0.0-0.GA.1
- Upgrade to 2.0.0

* Mon Jul 27 2009 Permaine Cheung <pcheung@redhat.com> 1.2.1-0.GA.4
- Fix the name of poms

* Mon Jul 27 2009 Permaine Cheung <pcheung@redhat.com> 1.2.1-0.GA.3
- Fix the name of juddi-parent pom

* Sun Jul 26 2009 Permaine Cheung <pcheung@redhat.com> 1.2.1-0.GA.2
- Fix component-info.xml

* Sun Jul 26 2009 Permaine Cheung <pcheung@redhat.com> 1.2.1-0.GA.1
- Upgrade to 1.2.1
- Update depmap, add poms and maven fragments

* Wed Jan 14 2009 Permaine Cheung <pcheung@redhat.com> 1.2.0.SP2-0jpp.ep1.3
- Remove BR: maven-shared-archiver

* Wed Jan 14 2009 Permaine Cheung <pcheung@redhat.com> 1.2.0.SP2-0jpp.ep1.2
- Includes sources.jar

* Wed Dec 10 2008 Permaine Cheung <pcheung@redhat.com> 1.2.0.SP2-0jpp.ep1.1
- Upgrade to 1.2.0.SP2
- Add patch to disable jboss-packaging-maven-plugin
- Add BR: maven-shared-archiver
- Update patch to specify jar as packaging tag for juddi-service

* Tue Dec 02 2008 Fernando Nasser <fnasser@redhat.com> 1.2.0.SP1-0jpp.ep1.6
- Add compatible line for apache-scout 0.7rc2-brew
- Enable use of scout repolib

* Fri Oct 17 2008 David Walluck <dwalluck@redhat.com> 0:1.2.0.SP1-0jpp.ep1.5
- build using correct version of juddi

* Tue Jul 08 2008 Permaine Cheung <pcheung@redhat.com> 1.2.0.SP1-0jpp.ep1.4
- Fix the jar/sar that go in repolib

* Wed Jun 20 2008 Yong Yang <yyang@redhat.com> 1.2.0.SP1-0jpp.ep1.2
- upgrade to SP1

* Wed Jun 18 2008 Yong Yang <yyang@redhat.com> 1.2.0.GA-0jpp.ep1.2
- Initial build
